// Copied from https://editoria11y.princeton.edu/configuration/#customtests.
document.addEventListener('ed11yRunCustomTests', function() {
  // 1. Write your custom test. This can be anything you want.
  const brokenLinksSelector = drupalSettings.editoria11y.editoria11y_si.broken_links;
  const siteimproveUrl = drupalSettings.editoria11y.editoria11y_si.siteimprove_url;
  Ed11y.findElements('editoria11ySiBrokenLinks', brokenLinksSelector);

  // 2. Create the content for your tip.
  Ed11y.M.editoria11ySiBrokenLinks = {
    // Provide a title and a body:
    title: 'Broken link',
    tip: (href) =>
        `<p>SiteImprove says the link is broken. Please update it.</p>
        <p>The specified URL is:<br>
        <em style='word-break: break-all;font-size:90%;line-height: 1.2;display: block;'>
            ${Ed11y.sanitizeForHTML(href)}
        </em></p>
        <div class="ed11y-tip-dismissals">
          <a href="${siteimproveUrl}" target="_blank">
            View SiteImprove page report
          </a>
        </div>`,
  };

  // 3. Push each item you want flagged to Ed11y.results.
  Ed11y.elements.editoria11ySiBrokenLinks?.forEach((el) => {
    Ed11y.results.push({
      element: el,
      test: 'editoria11ySiBrokenLinks',
      content: Ed11y.M.editoria11ySiBrokenLinks.tip(el.getAttribute('href')),
      position: 'beforebegin',
      dismissalKey: false,
    })
  })

  // 4. When you are done with all your custom tests, dispatch an "ed11yResume" event:
  let allDone = new CustomEvent('ed11yResume');
  document.dispatchEvent(allDone);
})
